import{s as ze,f as Oe,n as je,o as Be}from"../chunks/scheduler.f7e1785c.js";import{S as Se,i as De,g as a,s as l,r as E,A as Ue,h as s,f as n,c as i,j as Ge,u as G,x as r,k as z,y as Ne,a as o,v as O,d as j,t as B,w as S}from"../chunks/index.9f8f0838.js";import{H as ce}from"../chunks/Heading.6643a2f7.js";import{E as We}from"../chunks/EditOnGithub.d8925fc6.js";function Ke(we){let u,D,F,U,g,N,f,be="We’re now ready to fine-tune our first model for function-calling 🔥.",W,p,K,d,ve="<p>Answer : We need <strong>data</strong></p>",Q,h,Le="A model training can be divided into 3 steps :",Y,c,Te='<li><p><strong>The model is pretrained on a large quantity of data</strong>. The output of that step is a <strong>pre-trained model</strong>. For instance <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a>. It’s a base model and only knows how <strong>to predict the next token without good instruction following capacities</strong>.</p></li> <li><p>The model then, to be useful in chat context needs to be <strong>fine-tuned</strong> to follow instructions. In this step, it can be trained by the model creators, open-source community, you, or everyone. For instance <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a> is an instruct-tuned model by the Google Team behind the Gemma project.</p></li> <li><p>The model can then be <strong>aligned</strong> to the creator’s preference. For instance, a customer service chat model that must never be impolite to customers.</p></li>',J,w,$e="Usually a complete product like Gemini or Mistral <strong>will go through all 3 steps</strong> while the models you can find on Hugging Face have passed by one or more steps of this training.",V,b,ye='In this tutorial, we will build a function-calling model based on <a href="https://huggingface.co/google/gemma-2-2b-it" rel="nofollow">google/gemma-2-2b-it</a>. The base model is <a href="https://huggingface.co/google/gemma-2-2b" rel="nofollow">google/gemma-2-2b</a> and the Google team fine-tuned the base model on instruction following : resulting in <strong>“google/gemma-2-2b-it”</strong>.',X,v,xe="In this case we will take <strong>“google/gemma-2-2b-it”</strong> as base and <strong>not the base model because the prior fine-tuning it has been through is important for our use-case</strong>.",Z,L,_e="Since we want to interact with our model through conversations in messages, starting from the base model <strong>would require more training in order to learn instruction following, chat AND function-calling</strong>.",ee,T,Ce="By starting from the instruct-tuned model, <strong>we minimize the amount of information that our model needs to learn</strong>.",te,$,ne,y,Me="LoRA (Low-Rank Adaptation of Large Language Models) is a popular and lightweight training technique that significantly <strong>reduces the number of trainable parameters</strong>.",oe,x,ke="It works by <strong>inserting a smaller number of new weights as an adapter into the model to train</strong>. This makes training with LoRA much faster, memory-efficient, and produces smaller model weights (a few hundred MBs), which are easier to store and share.",le,m,He,ie,_,Pe="LoRA works by adding pairs of rank decomposition matrices to Transformer layers, typically focusing on linear layers. During training, we will “freeze” the rest of the model and will only update the weights of those newly added adapters.",ae,C,Ae="By doing so, the number of parameters that we need to train drops considerably as we only need to update the adapter’s weights.",se,M,Re="During inference, the input is passed into the adapter and the base model or these adapter weights can be merged with the base model, resulting in no additional latency overhead.",re,k,qe="LoRA is particularly useful for adapting <strong>large</strong> language models to specific tasks or domains while keeping resource requirements manageable. This helps reduce the memory required to train a model.",ue,H,Fe='If you want to learn more about how LoRA works, you should check this <a href="https://huggingface.co/learn/nlp-course/chapter11/4?fw=pt" rel="nofollow">tutorial</a>.',me,P,ge,A,Ie='You can access the tutorial notebook 👉 <a href="https://huggingface.co/agents-course/notebooks/blob/main/bonus-unit1/bonus-unit1.ipynb" rel="nofollow">here</a>.',fe,R,Ee="Then, click on Open In Colab to be able to run it in a Colab Notebook.",pe,q,de,I,he;return g=new ce({props:{title:"Let’s Fine-Tune your model for function-calling",local:"lets-fine-tune-your-model-for-function-calling",headingTag:"h1"}}),p=new ce({props:{title:"How do we train our model for function-calling ?",local:"how-do-we-train-our-model-for-function-calling-",headingTag:"h2"}}),$=new ce({props:{title:"LoRA  (Low-Rank Adaptation of Large Language Models)",local:"lora-low-rank-adaptation-of-large-language-models",headingTag:"h2"}}),P=new ce({props:{title:"Fine-Tuning a model for Function-calling",local:"fine-tuning-a-model-for-function-calling",headingTag:"h2"}}),q=new We({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/bonus-unit1/fine-tuning.mdx"}}),{c(){u=a("meta"),D=l(),F=a("p"),U=l(),E(g.$$.fragment),N=l(),f=a("p"),f.textContent=be,W=l(),E(p.$$.fragment),K=l(),d=a("blockquote"),d.innerHTML=ve,Q=l(),h=a("p"),h.textContent=Le,Y=l(),c=a("ol"),c.innerHTML=Te,J=l(),w=a("p"),w.innerHTML=$e,V=l(),b=a("p"),b.innerHTML=ye,X=l(),v=a("p"),v.innerHTML=xe,Z=l(),L=a("p"),L.innerHTML=_e,ee=l(),T=a("p"),T.innerHTML=Ce,te=l(),E($.$$.fragment),ne=l(),y=a("p"),y.innerHTML=Me,oe=l(),x=a("p"),x.innerHTML=ke,le=l(),m=a("img"),ie=l(),_=a("p"),_.textContent=Pe,ae=l(),C=a("p"),C.textContent=Ae,se=l(),M=a("p"),M.textContent=Re,re=l(),k=a("p"),k.innerHTML=qe,ue=l(),H=a("p"),H.innerHTML=Fe,me=l(),E(P.$$.fragment),ge=l(),A=a("p"),A.innerHTML=Ie,fe=l(),R=a("p"),R.textContent=Ee,pe=l(),E(q.$$.fragment),de=l(),I=a("p"),this.h()},l(e){const t=Ue("svelte-u9bgzb",document.head);u=s(t,"META",{name:!0,content:!0}),t.forEach(n),D=i(e),F=s(e,"P",{}),Ge(F).forEach(n),U=i(e),G(g.$$.fragment,e),N=i(e),f=s(e,"P",{"data-svelte-h":!0}),r(f)!=="svelte-1w2cdk2"&&(f.textContent=be),W=i(e),G(p.$$.fragment,e),K=i(e),d=s(e,"BLOCKQUOTE",{"data-svelte-h":!0}),r(d)!=="svelte-c6kegm"&&(d.innerHTML=ve),Q=i(e),h=s(e,"P",{"data-svelte-h":!0}),r(h)!=="svelte-i9kll6"&&(h.textContent=Le),Y=i(e),c=s(e,"OL",{"data-svelte-h":!0}),r(c)!=="svelte-1hy8a1n"&&(c.innerHTML=Te),J=i(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-hhn93a"&&(w.innerHTML=$e),V=i(e),b=s(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-wkarc2"&&(b.innerHTML=ye),X=i(e),v=s(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-sgc2l8"&&(v.innerHTML=xe),Z=i(e),L=s(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-1lbhq6s"&&(L.innerHTML=_e),ee=i(e),T=s(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-k03fx1"&&(T.innerHTML=Ce),te=i(e),G($.$$.fragment,e),ne=i(e),y=s(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-rxt3da"&&(y.innerHTML=Me),oe=i(e),x=s(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-noqyp3"&&(x.innerHTML=ke),le=i(e),m=s(e,"IMG",{src:!0,alt:!0,width:!0}),ie=i(e),_=s(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-ainuh8"&&(_.textContent=Pe),ae=i(e),C=s(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-180oj9p"&&(C.textContent=Ae),se=i(e),M=s(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-h93rxz"&&(M.textContent=Re),re=i(e),k=s(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-157mu6t"&&(k.innerHTML=qe),ue=i(e),H=s(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1t5so73"&&(H.innerHTML=Fe),me=i(e),G(P.$$.fragment,e),ge=i(e),A=s(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-jv048l"&&(A.innerHTML=Ie),fe=i(e),R=s(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-1vflt5z"&&(R.textContent=Ee),pe=i(e),G(q.$$.fragment,e),de=i(e),I=s(e,"P",{}),Ge(I).forEach(n),this.h()},h(){z(u,"name","hf:doc:metadata"),z(u,"content",Qe),Oe(m.src,He="https://huggingface.co/datasets/agents-course/course-images/resolve/main/en/unit1/blog_multi-lora-serving_LoRA.gif")||z(m,"src",He),z(m,"alt","LoRA inference"),z(m,"width","50%")},m(e,t){Ne(document.head,u),o(e,D,t),o(e,F,t),o(e,U,t),O(g,e,t),o(e,N,t),o(e,f,t),o(e,W,t),O(p,e,t),o(e,K,t),o(e,d,t),o(e,Q,t),o(e,h,t),o(e,Y,t),o(e,c,t),o(e,J,t),o(e,w,t),o(e,V,t),o(e,b,t),o(e,X,t),o(e,v,t),o(e,Z,t),o(e,L,t),o(e,ee,t),o(e,T,t),o(e,te,t),O($,e,t),o(e,ne,t),o(e,y,t),o(e,oe,t),o(e,x,t),o(e,le,t),o(e,m,t),o(e,ie,t),o(e,_,t),o(e,ae,t),o(e,C,t),o(e,se,t),o(e,M,t),o(e,re,t),o(e,k,t),o(e,ue,t),o(e,H,t),o(e,me,t),O(P,e,t),o(e,ge,t),o(e,A,t),o(e,fe,t),o(e,R,t),o(e,pe,t),O(q,e,t),o(e,de,t),o(e,I,t),he=!0},p:je,i(e){he||(j(g.$$.fragment,e),j(p.$$.fragment,e),j($.$$.fragment,e),j(P.$$.fragment,e),j(q.$$.fragment,e),he=!0)},o(e){B(g.$$.fragment,e),B(p.$$.fragment,e),B($.$$.fragment,e),B(P.$$.fragment,e),B(q.$$.fragment,e),he=!1},d(e){e&&(n(D),n(F),n(U),n(N),n(f),n(W),n(K),n(d),n(Q),n(h),n(Y),n(c),n(J),n(w),n(V),n(b),n(X),n(v),n(Z),n(L),n(ee),n(T),n(te),n(ne),n(y),n(oe),n(x),n(le),n(m),n(ie),n(_),n(ae),n(C),n(se),n(M),n(re),n(k),n(ue),n(H),n(me),n(ge),n(A),n(fe),n(R),n(pe),n(de),n(I)),n(u),S(g,e),S(p,e),S($,e),S(P,e),S(q,e)}}}const Qe='{"title":"Let’s Fine-Tune your model for function-calling","local":"lets-fine-tune-your-model-for-function-calling","sections":[{"title":"How do we train our model for function-calling ?","local":"how-do-we-train-our-model-for-function-calling-","sections":[],"depth":2},{"title":"LoRA  (Low-Rank Adaptation of Large Language Models)","local":"lora-low-rank-adaptation-of-large-language-models","sections":[],"depth":2},{"title":"Fine-Tuning a model for Function-calling","local":"fine-tuning-a-model-for-function-calling","sections":[],"depth":2}],"depth":1}';function Ye(we){return Be(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class et extends Se{constructor(u){super(),De(this,u,Ye,Ke,ze,{})}}export{et as component};
