import{s as et,o as tt,n as nt}from"../chunks/scheduler.f7e1785c.js";import{S as lt,i as st,g as a,s,r as x,A as it,h as r,f as n,c as i,j as Xe,x as g,u as C,k as Ze,y as ot,a as l,v as L,d as T,t as M,w as _,m as le,n as se}from"../chunks/index.9f8f0838.js";import{T as at}from"../chunks/Tip.4575d9cf.js";import{H as P}from"../chunks/Heading.6643a2f7.js";import{E as rt}from"../chunks/EditOnGithub.d8925fc6.js";function gt(ae){let u,h,A="@tool",y,f,ie="Tool",H,p,I="ToolCallingAgent",c,v,O="CodeAgents",d,$,w="ToolCallingAgent",S;return{c(){u=le("In smolagents, tools are defined using "),h=a("code"),h.textContent=A,y=le(" or the "),f=a("code"),f.textContent=ie,H=le(" class. They are distinct from "),p=a("code"),p.textContent=I,c=le(". Both "),v=a("code"),v.textContent=O,d=le(" and "),$=a("code"),$.textContent=w,S=le(" utilize tools. Keep this distinction in mind throughout the rest of the unit to avoid confusion!")},l(o){u=se(o,"In smolagents, tools are defined using "),h=r(o,"CODE",{"data-svelte-h":!0}),g(h)!=="svelte-1ni63dk"&&(h.textContent=A),y=se(o," or the "),f=r(o,"CODE",{"data-svelte-h":!0}),g(f)!=="svelte-q1isru"&&(f.textContent=ie),H=se(o," class. They are distinct from "),p=r(o,"CODE",{"data-svelte-h":!0}),g(p)!=="svelte-1a3cdqr"&&(p.textContent=I),c=se(o,". Both "),v=r(o,"CODE",{"data-svelte-h":!0}),g(v)!=="svelte-1hhf79v"&&(v.textContent=O),d=se(o," and "),$=r(o,"CODE",{"data-svelte-h":!0}),g($)!=="svelte-1a3cdqr"&&($.textContent=w),S=se(o," utilize tools. Keep this distinction in mind throughout the rest of the unit to avoid confusion!")},m(o,m){l(o,u,m),l(o,h,m),l(o,y,m),l(o,f,m),l(o,H,m),l(o,p,m),l(o,c,m),l(o,v,m),l(o,d,m),l(o,$,m),l(o,S,m)},p:nt,d(o){o&&(n(u),n(h),n(y),n(f),n(H),n(p),n(c),n(v),n(d),n($),n(S))}}}function mt(ae){let u,h,A,y,f,ie='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/smolagents/license_to_call.png" alt="smolagents banner"/>',H,p,I,c,v='In this module, we will explore the pros and cons of using <a href="https://huggingface.co/blog/smolagents" rel="nofollow">smolagents</a>, helping you make an informed decision about whether it’s the right framework for your needs.',O,d,$,w,S="<code>smolagents</code> is a simple yet powerful framework for building AI agents. It provides LLMs with the <em>agency</em> to interact with the real world, such as searching or generating images.",o,m,ke="As we learned in unit 1, AI agents are programs that use LLMs to generate <strong>‘thoughts’</strong> based on <strong>‘observations’</strong> to perform <strong>‘actions’</strong>. Let’s explore how this is implemented in smolagents.",re,k,ge,z,ze="<li><strong>Simplicity:</strong> Minimal code complexity and abstractions</li> <li><strong>Flexible LLM Support:</strong> Works with any LLM through integration with Hugging Face tools and external APIs</li> <li><strong>Code-First Approach:</strong> First-class support for Code Agents that directly write their actions in code</li> <li><strong>HF Hub Integration:</strong> Seamless integration with Hugging Face Hub, allowing the use of Gradio Spaces as tools</li>",me,E,fe,W,Ee="With these advantages in mind, when should we use smolagents over other frameworks?",pe,q,We="Smolagents is ideal when:",ue,j,qe="<li>You need a lightweight and minimal solution</li> <li>You want to experiment quickly without complex configurations</li> <li>Your application logic is straightforward</li>",he,F,ce,U,je="Unlike other frameworks where agents write actions in JSON that require parsing, <code>smolagents</code> focuses on direct tool calls in code, simplifying the execution process. The following diagram illustrates this difference:",de,J,Fe='<img src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/transformers/code_vs_json_actions.png" alt="Code vs. JSON actions"/>',$e,D,ve,N,Ue='Agents in <code>smolagents</code> operate as multi-step agents. Each <a href="https://huggingface.co/docs/smolagents/main/en/reference/agents#smolagents.MultiStepAgent" rel="nofollow"><code>MultiStepAgent</code></a> performs:',we,K,Je="<li>One thought</li> <li>One tool call and execution</li>",xe,B,De="The framework offers two types of agents:",Ce,R,Ne='<li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/agents#smolagents.CodeAgent" rel="nofollow">CodeAgent</a>:</strong> The default agent type that writes tool calls using Python</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/agents#smolagents.ToolCallingAgent" rel="nofollow">ToolCallingAgent</a>:</strong> Writes tool calls in JSON</li>',Le,Y,Ke="We will explore each agent type in more detail in the following units.",Te,b,Me,G,_e,Q,Be='<code>smolagents</code> supports flexible LLM integration, allowing you to use any callable model that meets <a href="https://huggingface.co/docs/smolagents/main/en/reference/models" rel="nofollow">certain criteria</a>. The framework provides several predefined classes to simplify model connections:',ye,V,Re='<li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.TransformersModel" rel="nofollow">TransformersModel</a>:</strong> Implements a local <code>transformers</code> pipeline for seamless integration.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.HfApiModel" rel="nofollow">HfApiModel</a>:</strong> Wraps Hugging Face’s <a href="https://huggingface.co/docs/huggingface_hub/main/en/guides/inference" rel="nofollow">InferenceClient</a> to support the <a href="https://huggingface.co/docs/api-inference/index" rel="nofollow">Inference API</a> and <a href="https://huggingface.co/blog/inference-providers" rel="nofollow">Inference Providers</a>.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.LiteLLMModel" rel="nofollow">LiteLLMModel</a>:</strong> Leverages <a href="https://www.litellm.ai/" rel="nofollow">LitLLM</a> for lightweight model interactions.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.OpenAIServerModel" rel="nofollow">OpenAIServerModel</a>:</strong> Connects to models compatible with the OpenAI API server.</li> <li><strong><a href="https://huggingface.co/docs/smolagents/main/en/reference/models#smolagents.AzureOpenAIServerModel" rel="nofollow">AzureOpenAIServerModel</a>:</strong> Supports integration with any Azure OpenAI deployment.</li>',He,X,Ye="This flexibility ensures that developers can choose the most suitable model integration for their specific use cases.",Ae,Z,Ge="Join us as we dive deep into smolagents in the upcoming sections!",be,ee,Pe,te,Qe='<li><a href="https://huggingface.co/blog/smolagents" rel="nofollow">smolagents Blog</a> - Introduction to smolagents and code interactions</li>',Ie,ne,Oe,oe,Se;return p=new P({props:{title:"Why use smolagents",local:"why-use-smolagents",headingTag:"h1"}}),d=new P({props:{title:"What is smolagents ?",local:"what-is-smolagents-",headingTag:"h2"}}),k=new P({props:{title:"Key Advantages of smolagents",local:"key-advantages-of-smolagents",headingTag:"h3"}}),E=new P({props:{title:"When to use smolagents",local:"when-to-use-smolagents",headingTag:"h3"}}),F=new P({props:{title:"Code vs. JSON Actions",local:"code-vs-json-actions",headingTag:"h3"}}),D=new P({props:{title:"Agent Types in smolagents",local:"agent-types-in-smolagents",headingTag:"h3"}}),b=new at({props:{$$slots:{default:[gt]},$$scope:{ctx:ae}}}),G=new P({props:{title:"Model Integration in smolagents",local:"model-integration-in-smolagents",headingTag:"h3"}}),ee=new P({props:{title:"Resources",local:"resources",headingTag:"h2"}}),ne=new rt({props:{source:"https://github.com/huggingface/agents-course/blob/main/units/en/unit2/smolagents/why_use_smolagents.md"}}),{c(){u=a("meta"),h=s(),A=a("p"),y=s(),f=a("p"),f.innerHTML=ie,H=s(),x(p.$$.fragment),I=s(),c=a("p"),c.innerHTML=v,O=s(),x(d.$$.fragment),$=s(),w=a("p"),w.innerHTML=S,o=s(),m=a("p"),m.innerHTML=ke,re=s(),x(k.$$.fragment),ge=s(),z=a("ul"),z.innerHTML=ze,me=s(),x(E.$$.fragment),fe=s(),W=a("p"),W.textContent=Ee,pe=s(),q=a("p"),q.textContent=We,ue=s(),j=a("ul"),j.innerHTML=qe,he=s(),x(F.$$.fragment),ce=s(),U=a("p"),U.innerHTML=je,de=s(),J=a("p"),J.innerHTML=Fe,$e=s(),x(D.$$.fragment),ve=s(),N=a("p"),N.innerHTML=Ue,we=s(),K=a("ul"),K.innerHTML=Je,xe=s(),B=a("p"),B.textContent=De,Ce=s(),R=a("ol"),R.innerHTML=Ne,Le=s(),Y=a("p"),Y.textContent=Ke,Te=s(),x(b.$$.fragment),Me=s(),x(G.$$.fragment),_e=s(),Q=a("p"),Q.innerHTML=Be,ye=s(),V=a("ul"),V.innerHTML=Re,He=s(),X=a("p"),X.textContent=Ye,Ae=s(),Z=a("p"),Z.textContent=Ge,be=s(),x(ee.$$.fragment),Pe=s(),te=a("ul"),te.innerHTML=Qe,Ie=s(),x(ne.$$.fragment),Oe=s(),oe=a("p"),this.h()},l(e){const t=it("svelte-u9bgzb",document.head);u=r(t,"META",{name:!0,content:!0}),t.forEach(n),h=i(e),A=r(e,"P",{}),Xe(A).forEach(n),y=i(e),f=r(e,"P",{"data-svelte-h":!0}),g(f)!=="svelte-y6hm8g"&&(f.innerHTML=ie),H=i(e),C(p.$$.fragment,e),I=i(e),c=r(e,"P",{"data-svelte-h":!0}),g(c)!=="svelte-2rqcag"&&(c.innerHTML=v),O=i(e),C(d.$$.fragment,e),$=i(e),w=r(e,"P",{"data-svelte-h":!0}),g(w)!=="svelte-1r6rx5a"&&(w.innerHTML=S),o=i(e),m=r(e,"P",{"data-svelte-h":!0}),g(m)!=="svelte-4bzfee"&&(m.innerHTML=ke),re=i(e),C(k.$$.fragment,e),ge=i(e),z=r(e,"UL",{"data-svelte-h":!0}),g(z)!=="svelte-158t2bm"&&(z.innerHTML=ze),me=i(e),C(E.$$.fragment,e),fe=i(e),W=r(e,"P",{"data-svelte-h":!0}),g(W)!=="svelte-8assml"&&(W.textContent=Ee),pe=i(e),q=r(e,"P",{"data-svelte-h":!0}),g(q)!=="svelte-1kme54"&&(q.textContent=We),ue=i(e),j=r(e,"UL",{"data-svelte-h":!0}),g(j)!=="svelte-1ik2924"&&(j.innerHTML=qe),he=i(e),C(F.$$.fragment,e),ce=i(e),U=r(e,"P",{"data-svelte-h":!0}),g(U)!=="svelte-x9z4oz"&&(U.innerHTML=je),de=i(e),J=r(e,"P",{"data-svelte-h":!0}),g(J)!=="svelte-igz6j7"&&(J.innerHTML=Fe),$e=i(e),C(D.$$.fragment,e),ve=i(e),N=r(e,"P",{"data-svelte-h":!0}),g(N)!=="svelte-suqs9k"&&(N.innerHTML=Ue),we=i(e),K=r(e,"UL",{"data-svelte-h":!0}),g(K)!=="svelte-86yvzc"&&(K.innerHTML=Je),xe=i(e),B=r(e,"P",{"data-svelte-h":!0}),g(B)!=="svelte-1faw156"&&(B.textContent=De),Ce=i(e),R=r(e,"OL",{"data-svelte-h":!0}),g(R)!=="svelte-1e0hf31"&&(R.innerHTML=Ne),Le=i(e),Y=r(e,"P",{"data-svelte-h":!0}),g(Y)!=="svelte-1cx6pbu"&&(Y.textContent=Ke),Te=i(e),C(b.$$.fragment,e),Me=i(e),C(G.$$.fragment,e),_e=i(e),Q=r(e,"P",{"data-svelte-h":!0}),g(Q)!=="svelte-1yzbre3"&&(Q.innerHTML=Be),ye=i(e),V=r(e,"UL",{"data-svelte-h":!0}),g(V)!=="svelte-2of43o"&&(V.innerHTML=Re),He=i(e),X=r(e,"P",{"data-svelte-h":!0}),g(X)!=="svelte-h2sync"&&(X.textContent=Ye),Ae=i(e),Z=r(e,"P",{"data-svelte-h":!0}),g(Z)!=="svelte-14q5jhi"&&(Z.textContent=Ge),be=i(e),C(ee.$$.fragment,e),Pe=i(e),te=r(e,"UL",{"data-svelte-h":!0}),g(te)!=="svelte-1nmm1j7"&&(te.innerHTML=Qe),Ie=i(e),C(ne.$$.fragment,e),Oe=i(e),oe=r(e,"P",{}),Xe(oe).forEach(n),this.h()},h(){Ze(u,"name","hf:doc:metadata"),Ze(u,"content",ft)},m(e,t){ot(document.head,u),l(e,h,t),l(e,A,t),l(e,y,t),l(e,f,t),l(e,H,t),L(p,e,t),l(e,I,t),l(e,c,t),l(e,O,t),L(d,e,t),l(e,$,t),l(e,w,t),l(e,o,t),l(e,m,t),l(e,re,t),L(k,e,t),l(e,ge,t),l(e,z,t),l(e,me,t),L(E,e,t),l(e,fe,t),l(e,W,t),l(e,pe,t),l(e,q,t),l(e,ue,t),l(e,j,t),l(e,he,t),L(F,e,t),l(e,ce,t),l(e,U,t),l(e,de,t),l(e,J,t),l(e,$e,t),L(D,e,t),l(e,ve,t),l(e,N,t),l(e,we,t),l(e,K,t),l(e,xe,t),l(e,B,t),l(e,Ce,t),l(e,R,t),l(e,Le,t),l(e,Y,t),l(e,Te,t),L(b,e,t),l(e,Me,t),L(G,e,t),l(e,_e,t),l(e,Q,t),l(e,ye,t),l(e,V,t),l(e,He,t),l(e,X,t),l(e,Ae,t),l(e,Z,t),l(e,be,t),L(ee,e,t),l(e,Pe,t),l(e,te,t),l(e,Ie,t),L(ne,e,t),l(e,Oe,t),l(e,oe,t),Se=!0},p(e,[t]){const Ve={};t&2&&(Ve.$$scope={dirty:t,ctx:e}),b.$set(Ve)},i(e){Se||(T(p.$$.fragment,e),T(d.$$.fragment,e),T(k.$$.fragment,e),T(E.$$.fragment,e),T(F.$$.fragment,e),T(D.$$.fragment,e),T(b.$$.fragment,e),T(G.$$.fragment,e),T(ee.$$.fragment,e),T(ne.$$.fragment,e),Se=!0)},o(e){M(p.$$.fragment,e),M(d.$$.fragment,e),M(k.$$.fragment,e),M(E.$$.fragment,e),M(F.$$.fragment,e),M(D.$$.fragment,e),M(b.$$.fragment,e),M(G.$$.fragment,e),M(ee.$$.fragment,e),M(ne.$$.fragment,e),Se=!1},d(e){e&&(n(h),n(A),n(y),n(f),n(H),n(I),n(c),n(O),n($),n(w),n(o),n(m),n(re),n(ge),n(z),n(me),n(fe),n(W),n(pe),n(q),n(ue),n(j),n(he),n(ce),n(U),n(de),n(J),n($e),n(ve),n(N),n(we),n(K),n(xe),n(B),n(Ce),n(R),n(Le),n(Y),n(Te),n(Me),n(_e),n(Q),n(ye),n(V),n(He),n(X),n(Ae),n(Z),n(be),n(Pe),n(te),n(Ie),n(Oe),n(oe)),n(u),_(p,e),_(d,e),_(k,e),_(E,e),_(F,e),_(D,e),_(b,e),_(G,e),_(ee,e),_(ne,e)}}}const ft='{"title":"Why use smolagents","local":"why-use-smolagents","sections":[{"title":"What is smolagents ?","local":"what-is-smolagents-","sections":[{"title":"Key Advantages of smolagents","local":"key-advantages-of-smolagents","sections":[],"depth":3},{"title":"When to use smolagents","local":"when-to-use-smolagents","sections":[],"depth":3},{"title":"Code vs. JSON Actions","local":"code-vs-json-actions","sections":[],"depth":3},{"title":"Agent Types in smolagents","local":"agent-types-in-smolagents","sections":[],"depth":3},{"title":"Model Integration in smolagents","local":"model-integration-in-smolagents","sections":[],"depth":3}],"depth":2},{"title":"Resources","local":"resources","sections":[],"depth":2}],"depth":1}';function pt(ae){return tt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class vt extends lt{constructor(u){super(),st(this,u,pt,mt,et,{})}}export{vt as component};
